# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class GetSaslUsersResult:
    """
    A collection of values returned by getSaslUsers.
    """
    def __init__(__self__, id=None, instance_id=None, name_regex=None, names=None, output_file=None, users=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        The provider-assigned unique ID for this managed resource.
        """
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        __self__.instance_id = instance_id
        if name_regex and not isinstance(name_regex, str):
            raise TypeError("Expected argument 'name_regex' to be a str")
        __self__.name_regex = name_regex
        if names and not isinstance(names, list):
            raise TypeError("Expected argument 'names' to be a list")
        __self__.names = names
        """
        A list of sasl usernames.
        """
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        __self__.output_file = output_file
        if users and not isinstance(users, list):
            raise TypeError("Expected argument 'users' to be a list")
        __self__.users = users
        """
        A list of sasl users. Each element contains the following attributes:
        """
class AwaitableGetSaslUsersResult(GetSaslUsersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSaslUsersResult(
            id=self.id,
            instance_id=self.instance_id,
            name_regex=self.name_regex,
            names=self.names,
            output_file=self.output_file,
            users=self.users)

def get_sasl_users(instance_id=None,name_regex=None,output_file=None,opts=None):
    """
    This data source provides a list of ALIKAFKA Sasl users in an Alibaba Cloud account according to the specified filters.

    > **NOTE:** Available in 1.66.0+

    ## Example Usage



    ```python
    import pulumi
    import pulumi_alicloud as alicloud

    sasl_users_ds = alicloud.actiontrail.get_sasl_users(instance_id="xxx",
        name_regex="username",
        output_file="saslUsers.txt")
    pulumi.export("firstSaslUsername", sasl_users_ds.users[0]["username"])
    ```



    :param str instance_id: ID of the ALIKAFKA Instance that owns the sasl users.
    :param str name_regex: A regex string to filter results by the username. 
    """
    __args__ = dict()


    __args__['instanceId'] = instance_id
    __args__['nameRegex'] = name_regex
    __args__['outputFile'] = output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('alicloud:actiontrail/getSaslUsers:getSaslUsers', __args__, opts=opts).value

    return AwaitableGetSaslUsersResult(
        id=__ret__.get('id'),
        instance_id=__ret__.get('instanceId'),
        name_regex=__ret__.get('nameRegex'),
        names=__ret__.get('names'),
        output_file=__ret__.get('outputFile'),
        users=__ret__.get('users'))
