# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class RouteMap(pulumi.CustomResource):
    as_path_match_mode: pulumi.Output[str]
    """
    A match statement. It indicates the mode in which the AS path attribute is matched. Valid values: ["Include", "Complete"].
    """
    cen_id: pulumi.Output[str]
    """
    The ID of the CEN instance.
    """
    cen_region_id: pulumi.Output[str]
    """
    The ID of the region to which the CEN instance belongs.
    """
    cidr_match_mode: pulumi.Output[str]
    """
    A match statement. It indicates the mode in which the prefix attribute is matched. Valid values: ["Include", "Complete"].
    """
    community_match_mode: pulumi.Output[str]
    """
    A match statement. It indicates the mode in which the community attribute is matched. Valid values: ["Include", "Complete"].
    """
    community_operate_mode: pulumi.Output[str]
    """
    An action statement. It indicates the mode in which the community attribute is operated. Valid values: ["Additive", "Replace"].
    """
    description: pulumi.Output[str]
    """
    The description of the route map.
    """
    destination_child_instance_types: pulumi.Output[list]
    """
    A match statement that indicates the list of destination instance types. Valid values: ["VPC", "VBR", "CCN"].
    """
    destination_cidr_blocks: pulumi.Output[list]
    """
    A match statement that indicates the prefix list. The prefix is in the CIDR format. You can enter a maximum of 32 CIDR blocks. 
    """
    destination_instance_ids: pulumi.Output[list]
    """
    A match statement that indicates the list of IDs of the destination instances.
    """
    destination_instance_ids_reverse_match: pulumi.Output[bool]
    """
    Indicates whether to enable the reverse match method for the DestinationInstanceIds match condition. Valid values: ["false", "true"]. Default to "false".
    """
    destination_route_table_ids: pulumi.Output[list]
    """
    A match statement that indicates the list of IDs of the destination route tables. You can enter a maximum of 32 route table IDs. 
    """
    map_result: pulumi.Output[str]
    """
    The action that is performed to a route if the route matches all the match conditions. Valid values: ["Permit", "Deny"].
    """
    match_asns: pulumi.Output[list]
    """
    A match statement that indicates the AS path list. The AS path is a well-known mandatory attribute, which describes the numbers of the ASs that a BGP route passes through during transmission. 
    """
    match_community_sets: pulumi.Output[list]
    """
    A match statement that indicates the community set. The format of each community is nn:nn, which ranges from 1 to 65535. You can enter a maximum of 32 communities. Communities must comply with RFC 1997. Large communities (RFC 8092) are not supported. 
    """
    next_priority: pulumi.Output[float]
    """
    The priority of the next route map that is associated with the current route map. Value range: 1 to 100.
    """
    operate_community_sets: pulumi.Output[list]
    """
    An action statement that operates the community attribute. The format of each community is nn:nn, which ranges from 1 to 65535. You can enter a maximum of 32 communities. Communities must comply with RFC 1997. Large communities (RFC 8092) are not supported. 
    """
    preference: pulumi.Output[float]
    """
    An action statement that modifies the priority of the route. Value range: 1 to 100. The default priority of a route is 50. A lower value indicates a higher preference. 
    """
    prepend_as_paths: pulumi.Output[list]
    """
    An action statement that indicates an AS path is prepended when the regional gateway receives or advertises a route.
    """
    priority: pulumi.Output[float]
    """
    The priority of the route map. Value range: 1 to 100. A lower value indicates a higher priority.
    """
    route_map_id: pulumi.Output[str]
    route_types: pulumi.Output[list]
    """
    A match statement that indicates the list of route types. Valid values: ["System", "Custom", "BGP"].
    """
    source_child_instance_types: pulumi.Output[list]
    """
    A match statement that indicates the list of source instance types. Valid values: ["VPC", "VBR", "CCN"].
    """
    source_instance_ids: pulumi.Output[list]
    """
    A match statement that indicates the list of IDs of the source instances. 
    """
    source_instance_ids_reverse_match: pulumi.Output[bool]
    """
    Indicates whether to enable the reverse match method for the SourceInstanceIds match condition. Valid values: ["false", "true"]. Default to "false".
    """
    source_region_ids: pulumi.Output[list]
    """
    A match statement that indicates the list of IDs of the source regions. You can enter a maximum of 32 region IDs.
    """
    source_route_table_ids: pulumi.Output[list]
    """
    A match statement that indicates the list of IDs of the source route tables. You can enter a maximum of 32 route table IDs. 
    """
    status: pulumi.Output[str]
    """
    (Computed) The status of route map. Valid values: ["Creating", "Active", "Deleting"].
    """
    transmit_direction: pulumi.Output[str]
    """
    The direction in which the route map is applied. Valid values: ["RegionIn", "RegionOut"].
    """
    def __init__(__self__, resource_name, opts=None, as_path_match_mode=None, cen_id=None, cen_region_id=None, cidr_match_mode=None, community_match_mode=None, community_operate_mode=None, description=None, destination_child_instance_types=None, destination_cidr_blocks=None, destination_instance_ids=None, destination_instance_ids_reverse_match=None, destination_route_table_ids=None, map_result=None, match_asns=None, match_community_sets=None, next_priority=None, operate_community_sets=None, preference=None, prepend_as_paths=None, priority=None, route_types=None, source_child_instance_types=None, source_instance_ids=None, source_instance_ids_reverse_match=None, source_region_ids=None, source_route_table_ids=None, transmit_direction=None, __props__=None, __name__=None, __opts__=None):
        """
        This topic provides an overview of the route map function of Cloud Enterprise Networks (CENs).
        You can use the route map function to filter routes and modify route attributes.
        By doing so, you can manage the communication between networks attached to a CEN. 

        For information about CEN Route Map and how to use it, see [Manage CEN Route Map](https://www.alibabacloud.com/help/doc-detail/124157.htm).

        > **NOTE:** Available in 1.82.0+

        ## Example Usage



        ```python
        import pulumi
        import pulumi_alicloud as alicloud
        import pulumi_pulumi as pulumi

        default_instance = alicloud.cen.Instance("defaultInstance")
        vpc00_region = pulumi.providers.Alicloud("vpc00Region", region="cn-hangzhou")
        vpc01_region = pulumi.providers.Alicloud("vpc01Region", region="cn-shanghai")
        vpc00 = alicloud.vpc.Network("vpc00", cidr_block="172.16.0.0/12")
        vpc01 = alicloud.vpc.Network("vpc01", cidr_block="172.16.0.0/12")
        default00 = alicloud.cen.InstanceAttachment("default00",
            child_instance_id=vpc00.id,
            child_instance_region_id="cn-hangzhou",
            instance_id=default_instance.id)
        default01 = alicloud.cen.InstanceAttachment("default01",
            child_instance_id=vpc01.id,
            child_instance_region_id="cn-shanghai",
            instance_id=default_instance.id)
        default_route_map = alicloud.cen.RouteMap("defaultRouteMap",
            as_path_match_mode="Include",
            cen_id=alicloud_cen_instance["cen"]["id"],
            cen_region_id="cn-hangzhou",
            cidr_match_mode="Include",
            community_match_mode="Include",
            community_operate_mode="Additive",
            description="test-desc",
            destination_child_instance_types=["VPC"],
            destination_cidr_blocks=[vpc01.cidr_block],
            destination_instance_ids=[vpc01.id],
            destination_instance_ids_reverse_match="false",
            destination_route_table_ids=[vpc01.route_table_id],
            map_result="Permit",
            match_asns=["65501"],
            match_community_sets=["65501:1"],
            next_priority="1",
            operate_community_sets=["65501:1"],
            preference="20",
            prepend_as_paths=["65501"],
            priority="1",
            route_types=["System"],
            source_child_instance_types=["VPC"],
            source_instance_ids=[vpc00.id],
            source_instance_ids_reverse_match="false",
            source_region_ids=["cn-hangzhou"],
            source_route_table_ids=[vpc00.route_table_id],
            transmit_direction="RegionIn")
        ```


        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] as_path_match_mode: A match statement. It indicates the mode in which the AS path attribute is matched. Valid values: ["Include", "Complete"].
        :param pulumi.Input[str] cen_id: The ID of the CEN instance.
        :param pulumi.Input[str] cen_region_id: The ID of the region to which the CEN instance belongs.
        :param pulumi.Input[str] cidr_match_mode: A match statement. It indicates the mode in which the prefix attribute is matched. Valid values: ["Include", "Complete"].
        :param pulumi.Input[str] community_match_mode: A match statement. It indicates the mode in which the community attribute is matched. Valid values: ["Include", "Complete"].
        :param pulumi.Input[str] community_operate_mode: An action statement. It indicates the mode in which the community attribute is operated. Valid values: ["Additive", "Replace"].
        :param pulumi.Input[str] description: The description of the route map.
        :param pulumi.Input[list] destination_child_instance_types: A match statement that indicates the list of destination instance types. Valid values: ["VPC", "VBR", "CCN"].
        :param pulumi.Input[list] destination_cidr_blocks: A match statement that indicates the prefix list. The prefix is in the CIDR format. You can enter a maximum of 32 CIDR blocks. 
        :param pulumi.Input[list] destination_instance_ids: A match statement that indicates the list of IDs of the destination instances.
        :param pulumi.Input[bool] destination_instance_ids_reverse_match: Indicates whether to enable the reverse match method for the DestinationInstanceIds match condition. Valid values: ["false", "true"]. Default to "false".
        :param pulumi.Input[list] destination_route_table_ids: A match statement that indicates the list of IDs of the destination route tables. You can enter a maximum of 32 route table IDs. 
        :param pulumi.Input[str] map_result: The action that is performed to a route if the route matches all the match conditions. Valid values: ["Permit", "Deny"].
        :param pulumi.Input[list] match_asns: A match statement that indicates the AS path list. The AS path is a well-known mandatory attribute, which describes the numbers of the ASs that a BGP route passes through during transmission. 
        :param pulumi.Input[list] match_community_sets: A match statement that indicates the community set. The format of each community is nn:nn, which ranges from 1 to 65535. You can enter a maximum of 32 communities. Communities must comply with RFC 1997. Large communities (RFC 8092) are not supported. 
        :param pulumi.Input[float] next_priority: The priority of the next route map that is associated with the current route map. Value range: 1 to 100.
        :param pulumi.Input[list] operate_community_sets: An action statement that operates the community attribute. The format of each community is nn:nn, which ranges from 1 to 65535. You can enter a maximum of 32 communities. Communities must comply with RFC 1997. Large communities (RFC 8092) are not supported. 
        :param pulumi.Input[float] preference: An action statement that modifies the priority of the route. Value range: 1 to 100. The default priority of a route is 50. A lower value indicates a higher preference. 
        :param pulumi.Input[list] prepend_as_paths: An action statement that indicates an AS path is prepended when the regional gateway receives or advertises a route.
        :param pulumi.Input[float] priority: The priority of the route map. Value range: 1 to 100. A lower value indicates a higher priority.
        :param pulumi.Input[list] route_types: A match statement that indicates the list of route types. Valid values: ["System", "Custom", "BGP"].
        :param pulumi.Input[list] source_child_instance_types: A match statement that indicates the list of source instance types. Valid values: ["VPC", "VBR", "CCN"].
        :param pulumi.Input[list] source_instance_ids: A match statement that indicates the list of IDs of the source instances. 
        :param pulumi.Input[bool] source_instance_ids_reverse_match: Indicates whether to enable the reverse match method for the SourceInstanceIds match condition. Valid values: ["false", "true"]. Default to "false".
        :param pulumi.Input[list] source_region_ids: A match statement that indicates the list of IDs of the source regions. You can enter a maximum of 32 region IDs.
        :param pulumi.Input[list] source_route_table_ids: A match statement that indicates the list of IDs of the source route tables. You can enter a maximum of 32 route table IDs. 
        :param pulumi.Input[str] transmit_direction: The direction in which the route map is applied. Valid values: ["RegionIn", "RegionOut"].
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['as_path_match_mode'] = as_path_match_mode
            if cen_id is None:
                raise TypeError("Missing required property 'cen_id'")
            __props__['cen_id'] = cen_id
            if cen_region_id is None:
                raise TypeError("Missing required property 'cen_region_id'")
            __props__['cen_region_id'] = cen_region_id
            __props__['cidr_match_mode'] = cidr_match_mode
            __props__['community_match_mode'] = community_match_mode
            __props__['community_operate_mode'] = community_operate_mode
            __props__['description'] = description
            __props__['destination_child_instance_types'] = destination_child_instance_types
            __props__['destination_cidr_blocks'] = destination_cidr_blocks
            __props__['destination_instance_ids'] = destination_instance_ids
            __props__['destination_instance_ids_reverse_match'] = destination_instance_ids_reverse_match
            __props__['destination_route_table_ids'] = destination_route_table_ids
            if map_result is None:
                raise TypeError("Missing required property 'map_result'")
            __props__['map_result'] = map_result
            __props__['match_asns'] = match_asns
            __props__['match_community_sets'] = match_community_sets
            __props__['next_priority'] = next_priority
            __props__['operate_community_sets'] = operate_community_sets
            __props__['preference'] = preference
            __props__['prepend_as_paths'] = prepend_as_paths
            if priority is None:
                raise TypeError("Missing required property 'priority'")
            __props__['priority'] = priority
            __props__['route_types'] = route_types
            __props__['source_child_instance_types'] = source_child_instance_types
            __props__['source_instance_ids'] = source_instance_ids
            __props__['source_instance_ids_reverse_match'] = source_instance_ids_reverse_match
            __props__['source_region_ids'] = source_region_ids
            __props__['source_route_table_ids'] = source_route_table_ids
            if transmit_direction is None:
                raise TypeError("Missing required property 'transmit_direction'")
            __props__['transmit_direction'] = transmit_direction
            __props__['route_map_id'] = None
            __props__['status'] = None
        super(RouteMap, __self__).__init__(
            'alicloud:cen/routeMap:RouteMap',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, as_path_match_mode=None, cen_id=None, cen_region_id=None, cidr_match_mode=None, community_match_mode=None, community_operate_mode=None, description=None, destination_child_instance_types=None, destination_cidr_blocks=None, destination_instance_ids=None, destination_instance_ids_reverse_match=None, destination_route_table_ids=None, map_result=None, match_asns=None, match_community_sets=None, next_priority=None, operate_community_sets=None, preference=None, prepend_as_paths=None, priority=None, route_map_id=None, route_types=None, source_child_instance_types=None, source_instance_ids=None, source_instance_ids_reverse_match=None, source_region_ids=None, source_route_table_ids=None, status=None, transmit_direction=None):
        """
        Get an existing RouteMap resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] as_path_match_mode: A match statement. It indicates the mode in which the AS path attribute is matched. Valid values: ["Include", "Complete"].
        :param pulumi.Input[str] cen_id: The ID of the CEN instance.
        :param pulumi.Input[str] cen_region_id: The ID of the region to which the CEN instance belongs.
        :param pulumi.Input[str] cidr_match_mode: A match statement. It indicates the mode in which the prefix attribute is matched. Valid values: ["Include", "Complete"].
        :param pulumi.Input[str] community_match_mode: A match statement. It indicates the mode in which the community attribute is matched. Valid values: ["Include", "Complete"].
        :param pulumi.Input[str] community_operate_mode: An action statement. It indicates the mode in which the community attribute is operated. Valid values: ["Additive", "Replace"].
        :param pulumi.Input[str] description: The description of the route map.
        :param pulumi.Input[list] destination_child_instance_types: A match statement that indicates the list of destination instance types. Valid values: ["VPC", "VBR", "CCN"].
        :param pulumi.Input[list] destination_cidr_blocks: A match statement that indicates the prefix list. The prefix is in the CIDR format. You can enter a maximum of 32 CIDR blocks. 
        :param pulumi.Input[list] destination_instance_ids: A match statement that indicates the list of IDs of the destination instances.
        :param pulumi.Input[bool] destination_instance_ids_reverse_match: Indicates whether to enable the reverse match method for the DestinationInstanceIds match condition. Valid values: ["false", "true"]. Default to "false".
        :param pulumi.Input[list] destination_route_table_ids: A match statement that indicates the list of IDs of the destination route tables. You can enter a maximum of 32 route table IDs. 
        :param pulumi.Input[str] map_result: The action that is performed to a route if the route matches all the match conditions. Valid values: ["Permit", "Deny"].
        :param pulumi.Input[list] match_asns: A match statement that indicates the AS path list. The AS path is a well-known mandatory attribute, which describes the numbers of the ASs that a BGP route passes through during transmission. 
        :param pulumi.Input[list] match_community_sets: A match statement that indicates the community set. The format of each community is nn:nn, which ranges from 1 to 65535. You can enter a maximum of 32 communities. Communities must comply with RFC 1997. Large communities (RFC 8092) are not supported. 
        :param pulumi.Input[float] next_priority: The priority of the next route map that is associated with the current route map. Value range: 1 to 100.
        :param pulumi.Input[list] operate_community_sets: An action statement that operates the community attribute. The format of each community is nn:nn, which ranges from 1 to 65535. You can enter a maximum of 32 communities. Communities must comply with RFC 1997. Large communities (RFC 8092) are not supported. 
        :param pulumi.Input[float] preference: An action statement that modifies the priority of the route. Value range: 1 to 100. The default priority of a route is 50. A lower value indicates a higher preference. 
        :param pulumi.Input[list] prepend_as_paths: An action statement that indicates an AS path is prepended when the regional gateway receives or advertises a route.
        :param pulumi.Input[float] priority: The priority of the route map. Value range: 1 to 100. A lower value indicates a higher priority.
        :param pulumi.Input[list] route_types: A match statement that indicates the list of route types. Valid values: ["System", "Custom", "BGP"].
        :param pulumi.Input[list] source_child_instance_types: A match statement that indicates the list of source instance types. Valid values: ["VPC", "VBR", "CCN"].
        :param pulumi.Input[list] source_instance_ids: A match statement that indicates the list of IDs of the source instances. 
        :param pulumi.Input[bool] source_instance_ids_reverse_match: Indicates whether to enable the reverse match method for the SourceInstanceIds match condition. Valid values: ["false", "true"]. Default to "false".
        :param pulumi.Input[list] source_region_ids: A match statement that indicates the list of IDs of the source regions. You can enter a maximum of 32 region IDs.
        :param pulumi.Input[list] source_route_table_ids: A match statement that indicates the list of IDs of the source route tables. You can enter a maximum of 32 route table IDs. 
        :param pulumi.Input[str] status: (Computed) The status of route map. Valid values: ["Creating", "Active", "Deleting"].
        :param pulumi.Input[str] transmit_direction: The direction in which the route map is applied. Valid values: ["RegionIn", "RegionOut"].
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["as_path_match_mode"] = as_path_match_mode
        __props__["cen_id"] = cen_id
        __props__["cen_region_id"] = cen_region_id
        __props__["cidr_match_mode"] = cidr_match_mode
        __props__["community_match_mode"] = community_match_mode
        __props__["community_operate_mode"] = community_operate_mode
        __props__["description"] = description
        __props__["destination_child_instance_types"] = destination_child_instance_types
        __props__["destination_cidr_blocks"] = destination_cidr_blocks
        __props__["destination_instance_ids"] = destination_instance_ids
        __props__["destination_instance_ids_reverse_match"] = destination_instance_ids_reverse_match
        __props__["destination_route_table_ids"] = destination_route_table_ids
        __props__["map_result"] = map_result
        __props__["match_asns"] = match_asns
        __props__["match_community_sets"] = match_community_sets
        __props__["next_priority"] = next_priority
        __props__["operate_community_sets"] = operate_community_sets
        __props__["preference"] = preference
        __props__["prepend_as_paths"] = prepend_as_paths
        __props__["priority"] = priority
        __props__["route_map_id"] = route_map_id
        __props__["route_types"] = route_types
        __props__["source_child_instance_types"] = source_child_instance_types
        __props__["source_instance_ids"] = source_instance_ids
        __props__["source_instance_ids_reverse_match"] = source_instance_ids_reverse_match
        __props__["source_region_ids"] = source_region_ids
        __props__["source_route_table_ids"] = source_route_table_ids
        __props__["status"] = status
        __props__["transmit_direction"] = transmit_direction
        return RouteMap(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

