# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class AutoProvisioningGroup(pulumi.CustomResource):
    auto_provisioning_group_name: pulumi.Output[str]
    auto_provisioning_group_type: pulumi.Output[str]
    default_target_capacity_type: pulumi.Output[str]
    """
    The type of supplemental instances. When the total value of `PayAsYouGoTargetCapacity` and `SpotTargetCapacity` is smaller than the value of TotalTargetCapacity, the auto provisioning group will create instances of the specified type to meet the capacity requirements. Valid values:`PayAsYouGo`: Pay-as-you-go instances; `Spot`: Preemptible instances, Default value: `Spot`.
    """
    description: pulumi.Output[str]
    """
    The description of the auto provisioning group.
    """
    excess_capacity_termination_policy: pulumi.Output[str]
    """
    The shutdown policy for excess preemptible instances followed when the capacity of the auto provisioning group exceeds the target capacity. Valid values: `no-termination` and `termination`,Default value: `no-termination`.
    """
    launch_template_configs: pulumi.Output[list]
    """
    DataDisk mappings to attach to ecs instance. See Block config below for details.

      * `instance_type` (`str`)
      * `maxPrice` (`str`)
      * `priority` (`str`)
      * `vswitch_id` (`str`)
      * `weightedCapacity` (`str`)
    """
    launch_template_id: pulumi.Output[str]
    """
    The ID of the instance launch template associated with the auto provisioning group.
    """
    launch_template_version: pulumi.Output[str]
    """
    The version of the instance launch template associated with the auto provisioning group.
    """
    max_spot_price: pulumi.Output[float]
    """
    The global maximum price for preemptible instances in the auto provisioning group. If both the `MaxSpotPrice` and `LaunchTemplateConfig.N.MaxPrice` parameters are specified, the maximum price is the lower value of the two.
    """
    pay_as_you_go_allocation_strategy: pulumi.Output[str]
    """
    The scale-out policy for pay-as-you-go instances. Valid values: `lowest-price` and `prioritized`,Default value: `lowest-price`.
    """
    pay_as_you_go_target_capacity: pulumi.Output[str]
    """
    The target capacity of pay-as-you-go instances in the auto provisioning group.
    """
    spot_allocation_strategy: pulumi.Output[str]
    """
    The scale-out policy for preemptible instances. Valid values:`lowest-price` and `diversified`,Default value: `lowest-price`.
    """
    spot_instance_interruption_behavior: pulumi.Output[str]
    """
    The default behavior after preemptible instances are shut down. Value values: `stop` and `terminate`,Default value: `stop`.
    """
    spot_instance_pools_to_use_count: pulumi.Output[float]
    """
    This parameter takes effect when the `SpotAllocationStrategy` parameter is set to `lowest-price`. The auto provisioning group selects instance types of the lowest cost to create instances.
    """
    spot_target_capacity: pulumi.Output[str]
    """
    The target capacity of preemptible instances in the auto provisioning group.
    """
    terminate_instances: pulumi.Output[bool]
    """
    Specifies whether to release instances of the auto provisioning group. Valid values:`false` and `true`, default value: `false`.
    """
    terminate_instances_with_expiration: pulumi.Output[bool]
    """
    The shutdown policy for preemptible instances when the auto provisioning group expires. Valid values: `false` and `true`, default value: `false`.
    """
    total_target_capacity: pulumi.Output[str]
    """
    The total target capacity of the auto provisioning group. The target capacity consists of the following three parts:PayAsYouGoTargetCapacity,SpotTargetCapacity and the supplemental capacity besides PayAsYouGoTargetCapacity and SpotTargetCapacity.
    """
    valid_from: pulumi.Output[str]
    """
    The time when the auto provisioning group is started. The period of time between this point in time and the point in time specified by the `valid_until` parameter is the effective time period of the auto provisioning group.By default, an auto provisioning group is immediately started after creation.
    """
    valid_until: pulumi.Output[str]
    """
    The time when the auto provisioning group expires. The period of time between this point in time and the point in time specified by the `valid_from` parameter is the effective time period of the auto provisioning group.By default, an auto provisioning group never expires.
    """
    def __init__(__self__, resource_name, opts=None, auto_provisioning_group_name=None, auto_provisioning_group_type=None, default_target_capacity_type=None, description=None, excess_capacity_termination_policy=None, launch_template_configs=None, launch_template_id=None, launch_template_version=None, max_spot_price=None, pay_as_you_go_allocation_strategy=None, pay_as_you_go_target_capacity=None, spot_allocation_strategy=None, spot_instance_interruption_behavior=None, spot_instance_pools_to_use_count=None, spot_target_capacity=None, terminate_instances=None, terminate_instances_with_expiration=None, total_target_capacity=None, valid_from=None, valid_until=None, __props__=None, __name__=None, __opts__=None):
        """
        Provides a ECS auto provisioning group resource which is a solution that uses preemptive instances and pay_as_you_go instances to rapidly deploy clusters.

        > **NOTE:** Available in 1.79.0+


        ## Example Usage



        ```python
        import pulumi
        import pulumi_alicloud as alicloud

        config = pulumi.Config()
        name = config.get("name")
        if name is None:
            name = "auto_provisioning_group"
        default_zones = alicloud.get_zones(available_disk_category="cloud_efficiency",
            available_resource_creation="VSwitch")
        default_network = alicloud.vpc.Network("defaultNetwork", cidr_block="172.16.0.0/16")
        default_switch = alicloud.vpc.Switch("defaultSwitch",
            availability_zone=default_zones.zones[0]["id"],
            cidr_block="172.16.0.0/24",
            vpc_id=default_network.id)
        default_security_group = alicloud.ecs.SecurityGroup("defaultSecurityGroup", vpc_id=default_network.id)
        default_images = alicloud.ecs.get_images(most_recent=True,
            name_regex="^ubuntu_18.*64",
            owners="system")
        template = alicloud.ecs.LaunchTemplate("template",
            image_id=default_images.images[0]["id"],
            instance_type="ecs.n1.tiny",
            security_group_id=default_security_group.id)
        default_auto_provisioning_group = alicloud.ecs.AutoProvisioningGroup("defaultAutoProvisioningGroup",
            launch_template_configs=[{
                "instanceType": "ecs.n1.small",
                "vswitchId": default_switch.id,
            }],
            launch_template_id=template.id,
            pay_as_you_go_target_capacity="1",
            spot_target_capacity="2",
            total_target_capacity="4")
        ```

        ## Block config

        The config mapping supports the following:
        * `instance_type` - (Optional) The instance type of the Nth extended configurations of the launch template.
        * `max_price` - (Required) The maximum price of the instance type specified in the Nth extended configurations of the launch template.
        * `vswitch_id` - (Required) The ID of the VSwitch in the Nth extended configurations of the launch template.
        * `weighted_capacity` - (Optional) The weight of the instance type specified in the Nth extended configurations of the launch template.
        * `priority` - (Optional) The priority of the instance type specified in the Nth extended configurations of the launch template. A value of 0 indicates the highest priority.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] default_target_capacity_type: The type of supplemental instances. When the total value of `PayAsYouGoTargetCapacity` and `SpotTargetCapacity` is smaller than the value of TotalTargetCapacity, the auto provisioning group will create instances of the specified type to meet the capacity requirements. Valid values:`PayAsYouGo`: Pay-as-you-go instances; `Spot`: Preemptible instances, Default value: `Spot`.
        :param pulumi.Input[str] description: The description of the auto provisioning group.
        :param pulumi.Input[str] excess_capacity_termination_policy: The shutdown policy for excess preemptible instances followed when the capacity of the auto provisioning group exceeds the target capacity. Valid values: `no-termination` and `termination`,Default value: `no-termination`.
        :param pulumi.Input[list] launch_template_configs: DataDisk mappings to attach to ecs instance. See Block config below for details.
        :param pulumi.Input[str] launch_template_id: The ID of the instance launch template associated with the auto provisioning group.
        :param pulumi.Input[str] launch_template_version: The version of the instance launch template associated with the auto provisioning group.
        :param pulumi.Input[float] max_spot_price: The global maximum price for preemptible instances in the auto provisioning group. If both the `MaxSpotPrice` and `LaunchTemplateConfig.N.MaxPrice` parameters are specified, the maximum price is the lower value of the two.
        :param pulumi.Input[str] pay_as_you_go_allocation_strategy: The scale-out policy for pay-as-you-go instances. Valid values: `lowest-price` and `prioritized`,Default value: `lowest-price`.
        :param pulumi.Input[str] pay_as_you_go_target_capacity: The target capacity of pay-as-you-go instances in the auto provisioning group.
        :param pulumi.Input[str] spot_allocation_strategy: The scale-out policy for preemptible instances. Valid values:`lowest-price` and `diversified`,Default value: `lowest-price`.
        :param pulumi.Input[str] spot_instance_interruption_behavior: The default behavior after preemptible instances are shut down. Value values: `stop` and `terminate`,Default value: `stop`.
        :param pulumi.Input[float] spot_instance_pools_to_use_count: This parameter takes effect when the `SpotAllocationStrategy` parameter is set to `lowest-price`. The auto provisioning group selects instance types of the lowest cost to create instances.
        :param pulumi.Input[str] spot_target_capacity: The target capacity of preemptible instances in the auto provisioning group.
        :param pulumi.Input[bool] terminate_instances: Specifies whether to release instances of the auto provisioning group. Valid values:`false` and `true`, default value: `false`.
        :param pulumi.Input[bool] terminate_instances_with_expiration: The shutdown policy for preemptible instances when the auto provisioning group expires. Valid values: `false` and `true`, default value: `false`.
        :param pulumi.Input[str] total_target_capacity: The total target capacity of the auto provisioning group. The target capacity consists of the following three parts:PayAsYouGoTargetCapacity,SpotTargetCapacity and the supplemental capacity besides PayAsYouGoTargetCapacity and SpotTargetCapacity.
        :param pulumi.Input[str] valid_from: The time when the auto provisioning group is started. The period of time between this point in time and the point in time specified by the `valid_until` parameter is the effective time period of the auto provisioning group.By default, an auto provisioning group is immediately started after creation.
        :param pulumi.Input[str] valid_until: The time when the auto provisioning group expires. The period of time between this point in time and the point in time specified by the `valid_from` parameter is the effective time period of the auto provisioning group.By default, an auto provisioning group never expires.

        The **launch_template_configs** object supports the following:

          * `instance_type` (`pulumi.Input[str]`)
          * `maxPrice` (`pulumi.Input[str]`)
          * `priority` (`pulumi.Input[str]`)
          * `vswitch_id` (`pulumi.Input[str]`)
          * `weightedCapacity` (`pulumi.Input[str]`)
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['auto_provisioning_group_name'] = auto_provisioning_group_name
            __props__['auto_provisioning_group_type'] = auto_provisioning_group_type
            __props__['default_target_capacity_type'] = default_target_capacity_type
            __props__['description'] = description
            __props__['excess_capacity_termination_policy'] = excess_capacity_termination_policy
            if launch_template_configs is None:
                raise TypeError("Missing required property 'launch_template_configs'")
            __props__['launch_template_configs'] = launch_template_configs
            if launch_template_id is None:
                raise TypeError("Missing required property 'launch_template_id'")
            __props__['launch_template_id'] = launch_template_id
            __props__['launch_template_version'] = launch_template_version
            __props__['max_spot_price'] = max_spot_price
            __props__['pay_as_you_go_allocation_strategy'] = pay_as_you_go_allocation_strategy
            __props__['pay_as_you_go_target_capacity'] = pay_as_you_go_target_capacity
            __props__['spot_allocation_strategy'] = spot_allocation_strategy
            __props__['spot_instance_interruption_behavior'] = spot_instance_interruption_behavior
            __props__['spot_instance_pools_to_use_count'] = spot_instance_pools_to_use_count
            __props__['spot_target_capacity'] = spot_target_capacity
            __props__['terminate_instances'] = terminate_instances
            __props__['terminate_instances_with_expiration'] = terminate_instances_with_expiration
            if total_target_capacity is None:
                raise TypeError("Missing required property 'total_target_capacity'")
            __props__['total_target_capacity'] = total_target_capacity
            __props__['valid_from'] = valid_from
            __props__['valid_until'] = valid_until
        super(AutoProvisioningGroup, __self__).__init__(
            'alicloud:ecs/autoProvisioningGroup:AutoProvisioningGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, auto_provisioning_group_name=None, auto_provisioning_group_type=None, default_target_capacity_type=None, description=None, excess_capacity_termination_policy=None, launch_template_configs=None, launch_template_id=None, launch_template_version=None, max_spot_price=None, pay_as_you_go_allocation_strategy=None, pay_as_you_go_target_capacity=None, spot_allocation_strategy=None, spot_instance_interruption_behavior=None, spot_instance_pools_to_use_count=None, spot_target_capacity=None, terminate_instances=None, terminate_instances_with_expiration=None, total_target_capacity=None, valid_from=None, valid_until=None):
        """
        Get an existing AutoProvisioningGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] default_target_capacity_type: The type of supplemental instances. When the total value of `PayAsYouGoTargetCapacity` and `SpotTargetCapacity` is smaller than the value of TotalTargetCapacity, the auto provisioning group will create instances of the specified type to meet the capacity requirements. Valid values:`PayAsYouGo`: Pay-as-you-go instances; `Spot`: Preemptible instances, Default value: `Spot`.
        :param pulumi.Input[str] description: The description of the auto provisioning group.
        :param pulumi.Input[str] excess_capacity_termination_policy: The shutdown policy for excess preemptible instances followed when the capacity of the auto provisioning group exceeds the target capacity. Valid values: `no-termination` and `termination`,Default value: `no-termination`.
        :param pulumi.Input[list] launch_template_configs: DataDisk mappings to attach to ecs instance. See Block config below for details.
        :param pulumi.Input[str] launch_template_id: The ID of the instance launch template associated with the auto provisioning group.
        :param pulumi.Input[str] launch_template_version: The version of the instance launch template associated with the auto provisioning group.
        :param pulumi.Input[float] max_spot_price: The global maximum price for preemptible instances in the auto provisioning group. If both the `MaxSpotPrice` and `LaunchTemplateConfig.N.MaxPrice` parameters are specified, the maximum price is the lower value of the two.
        :param pulumi.Input[str] pay_as_you_go_allocation_strategy: The scale-out policy for pay-as-you-go instances. Valid values: `lowest-price` and `prioritized`,Default value: `lowest-price`.
        :param pulumi.Input[str] pay_as_you_go_target_capacity: The target capacity of pay-as-you-go instances in the auto provisioning group.
        :param pulumi.Input[str] spot_allocation_strategy: The scale-out policy for preemptible instances. Valid values:`lowest-price` and `diversified`,Default value: `lowest-price`.
        :param pulumi.Input[str] spot_instance_interruption_behavior: The default behavior after preemptible instances are shut down. Value values: `stop` and `terminate`,Default value: `stop`.
        :param pulumi.Input[float] spot_instance_pools_to_use_count: This parameter takes effect when the `SpotAllocationStrategy` parameter is set to `lowest-price`. The auto provisioning group selects instance types of the lowest cost to create instances.
        :param pulumi.Input[str] spot_target_capacity: The target capacity of preemptible instances in the auto provisioning group.
        :param pulumi.Input[bool] terminate_instances: Specifies whether to release instances of the auto provisioning group. Valid values:`false` and `true`, default value: `false`.
        :param pulumi.Input[bool] terminate_instances_with_expiration: The shutdown policy for preemptible instances when the auto provisioning group expires. Valid values: `false` and `true`, default value: `false`.
        :param pulumi.Input[str] total_target_capacity: The total target capacity of the auto provisioning group. The target capacity consists of the following three parts:PayAsYouGoTargetCapacity,SpotTargetCapacity and the supplemental capacity besides PayAsYouGoTargetCapacity and SpotTargetCapacity.
        :param pulumi.Input[str] valid_from: The time when the auto provisioning group is started. The period of time between this point in time and the point in time specified by the `valid_until` parameter is the effective time period of the auto provisioning group.By default, an auto provisioning group is immediately started after creation.
        :param pulumi.Input[str] valid_until: The time when the auto provisioning group expires. The period of time between this point in time and the point in time specified by the `valid_from` parameter is the effective time period of the auto provisioning group.By default, an auto provisioning group never expires.

        The **launch_template_configs** object supports the following:

          * `instance_type` (`pulumi.Input[str]`)
          * `maxPrice` (`pulumi.Input[str]`)
          * `priority` (`pulumi.Input[str]`)
          * `vswitch_id` (`pulumi.Input[str]`)
          * `weightedCapacity` (`pulumi.Input[str]`)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["auto_provisioning_group_name"] = auto_provisioning_group_name
        __props__["auto_provisioning_group_type"] = auto_provisioning_group_type
        __props__["default_target_capacity_type"] = default_target_capacity_type
        __props__["description"] = description
        __props__["excess_capacity_termination_policy"] = excess_capacity_termination_policy
        __props__["launch_template_configs"] = launch_template_configs
        __props__["launch_template_id"] = launch_template_id
        __props__["launch_template_version"] = launch_template_version
        __props__["max_spot_price"] = max_spot_price
        __props__["pay_as_you_go_allocation_strategy"] = pay_as_you_go_allocation_strategy
        __props__["pay_as_you_go_target_capacity"] = pay_as_you_go_target_capacity
        __props__["spot_allocation_strategy"] = spot_allocation_strategy
        __props__["spot_instance_interruption_behavior"] = spot_instance_interruption_behavior
        __props__["spot_instance_pools_to_use_count"] = spot_instance_pools_to_use_count
        __props__["spot_target_capacity"] = spot_target_capacity
        __props__["terminate_instances"] = terminate_instances
        __props__["terminate_instances_with_expiration"] = terminate_instances_with_expiration
        __props__["total_target_capacity"] = total_target_capacity
        __props__["valid_from"] = valid_from
        __props__["valid_until"] = valid_until
        return AutoProvisioningGroup(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

