# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class GetClustersResult:
    """
    A collection of values returned by getClusters.
    """
    def __init__(__self__, clusters=None, id=None, ids=None, logical_region_id=None, name_regex=None, names=None, output_file=None):
        if clusters and not isinstance(clusters, list):
            raise TypeError("Expected argument 'clusters' to be a list")
        __self__.clusters = clusters
        """
        A list of clusters.
        """
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        The provider-assigned unique ID for this managed resource.
        """
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        __self__.ids = ids
        """
        A list of cluster IDs.
        """
        if logical_region_id and not isinstance(logical_region_id, str):
            raise TypeError("Expected argument 'logical_region_id' to be a str")
        __self__.logical_region_id = logical_region_id
        if name_regex and not isinstance(name_regex, str):
            raise TypeError("Expected argument 'name_regex' to be a str")
        __self__.name_regex = name_regex
        if names and not isinstance(names, list):
            raise TypeError("Expected argument 'names' to be a list")
        __self__.names = names
        """
        A list of cluster names.
        """
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        __self__.output_file = output_file
class AwaitableGetClustersResult(GetClustersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetClustersResult(
            clusters=self.clusters,
            id=self.id,
            ids=self.ids,
            logical_region_id=self.logical_region_id,
            name_regex=self.name_regex,
            names=self.names,
            output_file=self.output_file)

def get_clusters(ids=None,logical_region_id=None,name_regex=None,output_file=None,opts=None):
    """
    This data source provides a list of EDAS clusters in an Alibaba Cloud account according to the specified filters.

    > **NOTE:** Available in 1.82.0+

    ## Example Usage



    ```python
    import pulumi
    import pulumi_alicloud as alicloud

    clusters = alicloud.edas.get_clusters(logical_region_id="cn-shenzhen:xxx",
        ids=["addfs-dfsasd"],
        output_file="clusters.txt")
    pulumi.export("firstClusterName", data["actiontrail.getConsumerGroups"]["clusters"]["clusters"][0]["cluster_name"])
    ```



    :param list ids: An ids string to filter results by the cluster id. 
    :param str logical_region_id: ID of the namespace in EDAS.
    :param str name_regex: A regex string to filter results by the cluster name. 
    """
    __args__ = dict()


    __args__['ids'] = ids
    __args__['logicalRegionId'] = logical_region_id
    __args__['nameRegex'] = name_regex
    __args__['outputFile'] = output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('alicloud:edas/getClusters:getClusters', __args__, opts=opts).value

    return AwaitableGetClustersResult(
        clusters=__ret__.get('clusters'),
        id=__ret__.get('id'),
        ids=__ret__.get('ids'),
        logical_region_id=__ret__.get('logicalRegionId'),
        name_regex=__ret__.get('nameRegex'),
        names=__ret__.get('names'),
        output_file=__ret__.get('outputFile'))
