# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class Secret(pulumi.CustomResource):
    arn: pulumi.Output[str]
    """
    The Alicloud Resource Name (ARN) of the secret.
    """
    description: pulumi.Output[str]
    """
    The description of the secret.
    """
    encryption_key_id: pulumi.Output[str]
    """
    The ID of the KMS CMK that is used to encrypt the secret value. If you do not specify this parameter, Secrets Manager automatically creates an encryption key to encrypt the secret.
    """
    force_delete_without_recovery: pulumi.Output[bool]
    """
    Specifies whether to forcibly delete the secret. If this parameter is set to true, the secret cannot be recovered. Valid values: true, false. Default to: false.
    """
    planned_delete_time: pulumi.Output[str]
    """
    The time when the secret is scheduled to be deleted.
    """
    recovery_window_in_days: pulumi.Output[float]
    """
    Specifies the recovery period of the secret if you do not forcibly delete it. Default value: 30. It will be ignored when `force_delete_without_recovery` is true.
    """
    secret_data: pulumi.Output[str]
    """
    The value of the secret that you want to create. Secrets Manager encrypts the secret value and stores it in the initial version.
    """
    secret_data_type: pulumi.Output[str]
    """
    The type of the secret value. Valid values: text, binary. Default to "text".
    """
    secret_name: pulumi.Output[str]
    """
    The name of the secret.
    """
    tags: pulumi.Output[dict]
    """
    A mapping of tags to assign to the resource.
    """
    version_id: pulumi.Output[str]
    """
    The version number of the initial version. Version numbers are unique in each secret object.
    """
    version_stages: pulumi.Output[list]
    """
    ) The stage labels that mark the new secret version. If you do not specify this parameter, Secrets Manager marks it with "ACSCurrent".
    """
    def __init__(__self__, resource_name, opts=None, description=None, encryption_key_id=None, force_delete_without_recovery=None, recovery_window_in_days=None, secret_data=None, secret_data_type=None, secret_name=None, tags=None, version_id=None, version_stages=None, __props__=None, __name__=None, __opts__=None):
        """
        Create a Secret resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the secret.
        :param pulumi.Input[str] encryption_key_id: The ID of the KMS CMK that is used to encrypt the secret value. If you do not specify this parameter, Secrets Manager automatically creates an encryption key to encrypt the secret.
        :param pulumi.Input[bool] force_delete_without_recovery: Specifies whether to forcibly delete the secret. If this parameter is set to true, the secret cannot be recovered. Valid values: true, false. Default to: false.
        :param pulumi.Input[float] recovery_window_in_days: Specifies the recovery period of the secret if you do not forcibly delete it. Default value: 30. It will be ignored when `force_delete_without_recovery` is true.
        :param pulumi.Input[str] secret_data: The value of the secret that you want to create. Secrets Manager encrypts the secret value and stores it in the initial version.
        :param pulumi.Input[str] secret_data_type: The type of the secret value. Valid values: text, binary. Default to "text".
        :param pulumi.Input[str] secret_name: The name of the secret.
        :param pulumi.Input[dict] tags: A mapping of tags to assign to the resource.
        :param pulumi.Input[str] version_id: The version number of the initial version. Version numbers are unique in each secret object.
        :param pulumi.Input[list] version_stages: ) The stage labels that mark the new secret version. If you do not specify this parameter, Secrets Manager marks it with "ACSCurrent".
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['description'] = description
            __props__['encryption_key_id'] = encryption_key_id
            __props__['force_delete_without_recovery'] = force_delete_without_recovery
            __props__['recovery_window_in_days'] = recovery_window_in_days
            if secret_data is None:
                raise TypeError("Missing required property 'secret_data'")
            __props__['secret_data'] = secret_data
            __props__['secret_data_type'] = secret_data_type
            if secret_name is None:
                raise TypeError("Missing required property 'secret_name'")
            __props__['secret_name'] = secret_name
            __props__['tags'] = tags
            if version_id is None:
                raise TypeError("Missing required property 'version_id'")
            __props__['version_id'] = version_id
            __props__['version_stages'] = version_stages
            __props__['arn'] = None
            __props__['planned_delete_time'] = None
        super(Secret, __self__).__init__(
            'alicloud:kms/secret:Secret',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, arn=None, description=None, encryption_key_id=None, force_delete_without_recovery=None, planned_delete_time=None, recovery_window_in_days=None, secret_data=None, secret_data_type=None, secret_name=None, tags=None, version_id=None, version_stages=None):
        """
        Get an existing Secret resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] arn: The Alicloud Resource Name (ARN) of the secret.
        :param pulumi.Input[str] description: The description of the secret.
        :param pulumi.Input[str] encryption_key_id: The ID of the KMS CMK that is used to encrypt the secret value. If you do not specify this parameter, Secrets Manager automatically creates an encryption key to encrypt the secret.
        :param pulumi.Input[bool] force_delete_without_recovery: Specifies whether to forcibly delete the secret. If this parameter is set to true, the secret cannot be recovered. Valid values: true, false. Default to: false.
        :param pulumi.Input[str] planned_delete_time: The time when the secret is scheduled to be deleted.
        :param pulumi.Input[float] recovery_window_in_days: Specifies the recovery period of the secret if you do not forcibly delete it. Default value: 30. It will be ignored when `force_delete_without_recovery` is true.
        :param pulumi.Input[str] secret_data: The value of the secret that you want to create. Secrets Manager encrypts the secret value and stores it in the initial version.
        :param pulumi.Input[str] secret_data_type: The type of the secret value. Valid values: text, binary. Default to "text".
        :param pulumi.Input[str] secret_name: The name of the secret.
        :param pulumi.Input[dict] tags: A mapping of tags to assign to the resource.
        :param pulumi.Input[str] version_id: The version number of the initial version. Version numbers are unique in each secret object.
        :param pulumi.Input[list] version_stages: ) The stage labels that mark the new secret version. If you do not specify this parameter, Secrets Manager marks it with "ACSCurrent".
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["arn"] = arn
        __props__["description"] = description
        __props__["encryption_key_id"] = encryption_key_id
        __props__["force_delete_without_recovery"] = force_delete_without_recovery
        __props__["planned_delete_time"] = planned_delete_time
        __props__["recovery_window_in_days"] = recovery_window_in_days
        __props__["secret_data"] = secret_data
        __props__["secret_data_type"] = secret_data_type
        __props__["secret_name"] = secret_name
        __props__["tags"] = tags
        __props__["version_id"] = version_id
        __props__["version_stages"] = version_stages
        return Secret(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

